// copyright 2009 Chris Glasier - coding adviser - Jim Foltz 
var coreRunner
function coreSetRunner() {
	var path = window.location.href.split('/')
	var basename = path[path.length-1]
	coreRunner = basename.split('.')[1].toLowerCase()
	}

coreSetRunner()

function coreRubyReq(callback, params) {
	window.location = "skp:" + callback + "@" + params.join(';')
}

function coreStripe(dv){
	obj=document.createElement("div");
	document.body.appendChild(obj);
	obj.id = "stripe";
	obj.className = "stripe";
	obj.style.width = "100%"
}

function coreSliderHolder(c,ch,cl,cw,dh,dv,sl){
	obj=document.createElement("div");
	document.getElementById(dv+"Panel").appendChild(obj);
	obj.id = dv+c;
	obj.className  = "slider";
	obj.onmousedown = function() { coreDown(c,dv) }
	pos = sl[c].split(".");
	pos = pos[pos.length-1];
	pos = parseInt(pos);
	var rows = dh/ch;
	var stripeTop = Math.round((rows/2) - 1);
	if(pos < stripeTop) var theTop = stripeTop - pos +.5;
	else theTop = stripeTop - pos + .5;
	obj.style.top = theTop * ch; 
	obj.style.left = cw * c;
	obj.style.width = cw;
}

function coreSliderList(list, c) {
	with(config){
		var ch = cellheight, cl = columns, cw = colwidth 
		var dh = deviceheight, dv = device
		var sl = selection, sp = stripe, tp = type
	}
	document.getElementById(dv+c).innerHTML = ""
	var json = cl[c]
	var k = new Array();
	var n
	for (n in list) {
		ent = new Array(eval(json)[list[n]]["name"],list[n])
		k.push(ent)
	}	
	for(var d=0; d<k.length; d++){
		obj = document.createElement("div");
		document.getElementById(dv+c).appendChild(obj);
		with(obj){		
			id = k[d][1];  
			title = id		//testing
			innerHTML = k[d][0];
			className = "green"
			with(style){
				width = cw*.98;
				height = ch;
			}
		}
	}
}

function coreDown(c,dv){
	var cell;
	if (!e) {
		var e = window.event ; 
	}
	if (e.target){ 
		cell = e.target;  
	}
	else if (e.srcElement){
		cell = e.srcElement;  
	}
	with(config){
		var ch = cellheight , dh = deviceheight , dv = device
		var lc = lastcell,  sl = selection
	}
	var cId = cell.id
	//passes list/menu + serialNumber x or x.x
	if(cell.tagName == "INPUT") 		return;
	//provision for editable cells 
	var lstId 	= lc;
	var counter
	cId == lstId? counter = 1 : counter = 0;
	config["lastcell"]    		= cId;
	//click to navigate; again to activate device
	
	var slider 	= document.getElementById(dv+c)
	var cell_top = parseInt(cell.offsetTop)
	var slider_top = parseInt(slider.style.top) 
	var stripe_top = parseInt(document.getElementById('stripe').style.top)
	var dist = cell_top + slider_top - stripe_top
	var top = parseInt(slider.style.top) - dist
	animate(slider, 'top', slider_top, top, 500, 20, cId, counter, dv, c)
}

function animate(obj, elm, begin, end, duration, fps, cId, counter, dv, c) {

	if(!duration) duration = 1000;
	if(!fps)      fps      = 20;

	begin     = parseFloat(begin);
	end       = parseFloat(end);
	duration  = parseFloat(duration);
	fps       = parseFloat(fps);

	var change      = end-begin;
	var interval    = Math.ceil(1000/fps);
	var totalframes = Math.ceil(duration/interval);
	var step        = change/totalframes;
	for(i = 1 ;i <= totalframes; i++) {
		(function() {
			var frame=i;
			function inner() {
				var increase = easeQuadOut(frame, begin, change, totalframes);
				unit = 'px';
				obj.style[elm]  = increase+unit; 
			}
			timer = setTimeout(inner,interval*frame);
	   	}) ();
	
	}
	params = new Array(cId,counter);
	eval(dv+c+"Down")(params);	
}

function easeQuadOut(t, b, c, d) {
	return -c * (t/=d)*(t-2) + b;
}

function coreInput(i,v){
	obj = document.createElement("input");
	document.getElementById(i).appendChild(obj);
	obj.value = v;
	obj.id = "inp";
	obj.onmousedown = listsUpdateSet
	obj.style.width = "100%";
}


function coreDisplaySet(){
	var ch = config["cellheight"];
	var cl = config["columns"];
	var dv = config["device"];
	var dt =config["devicetop"];
	var pw= document.body.clientWidth;
    var ph = document.body.clientHeight;
	var dh = ph - dt;
	var rows = dh/ch;
	stripeTop = Math.round(rows/2)-.5; 
	document.getElementById("stripe").style.top = stripeTop*ch;
	document.getElementById("stripe").style.height = ch;
	var cw = pw/cl.length;
	config["stripe"] = stripeTop;
	config["colwidth"] = cw;
	config["deviceheight"] = dh;
}

function coreJsonLoad(fileName) {
	var ForReading = 1
	var fs = new ActiveXObject("Scripting.FileSystemObject")
	//var fileName = "AlexListcg2.json"
	if(fs.FileExists(fileName)) {
		var ts = fs.OpenTextFile(fileName, ForReading)
		var s = ts.ReadAll()
		ts.close()
		return( JSON.parse( s ))
	}
	else {
		alert("file doesn't exist:"+fileName)
	}
}

function coreJsonSave(fileName, json) {
	var ForWriting = 2
	var objFSO = new ActiveXObject("Scripting.FileSystemObject")
	var objFile = objFSO.CreateTextFile(fileName, ForWriting)
	objFile.Write( json )
	objFile.Close()
}

function log(name, value) {
	var append = 8
	var tp = typeof(value)
	var a = fso.OpenTextFile("logfile.txt", append)
	if (typeof(value) != "string") { value = JSON.stringify(value) }
	var str = name + " = " + value + " (" + tp + ")" 
	a.WriteLine( str )
	a.Close()
}
function logArgs(fname, args) {
    log("\n"+fname+": ", "")
	for(var i = 0; i < args.length; i++ ) {
		log("arg"+(i+1), args[i])
	}
}

if (coreRunner == "hta") {
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	var a = fso.CreateTextFile("logfile.txt", true);
	a.WriteLine(new Date());
	a.Close();
}
