// copyright 2009 Chris Glasier - coding adviser - Jim Foltz 
var config
var nset
var menus

function apiConfigSave() {
	config["left"] = window.screenLeft;
	config["top"] = window.screenTop;
	config["width"] = document.body.clientWidth;
	config["height"] = document.body.clientHeight;
	coreJsonSave('deviceConf.json', JSON.stringify(config) );
}

function apiResize(){
	apiRun();
}

// 
function apiStart(){
	if (coreRunner == "hta") {
		config = coreJsonLoad('deviceConf.json');
		menus = coreJsonLoad('deviceMenus.json');
		nset = coreJsonLoad('deviceNset.json');
		with(config){
			window.resizeTo(width , height);
			window.moveTo(left , top );
		}
		apiStart2()
	} else {
		//coreRubyReq('ruby_callback', [params array])
		coreRubyReq('send_json', ['apiConfigRec', 'deviceConf.json'])
	}
}

function apiConfigRec(json) {
	config = JSON.parse(json)
	coreRubyReq('send_json', ['apiMenusRec', 'deviceMenus.json'])
}
function apiMenusRec(json) {
	menus = JSON.parse(json)
	coreRubyReq('send_json', ['apiDataRec', 'deviceNset.json'])
}
function apiDataRec(json) {
	nset = JSON.parse(json)
	apiStart2()
}

function apiStart2() {
	coreStripe();
	apiRun(); 
}

function apiRun(){	
	with(config){
		var ch = cellheight;
		var cl = columns;
		var cw = colwidth;
		var dh = deviceheight;
		var dv = device;
		var sl = selection;
	}
	document.getElementById(dv+"Panel").innerHTML = "";
	coreDisplaySet(ch,cl);
	with(config){
		var cw = colwidth;
		var dh = deviceheight;
	}
	for(c=0; c<cl.length; c++){
		coreSliderHolder(c,ch,cl,cw,dh,dv,sl);
	}
	apiClassesAll(sl);
	apiMethodsList(sl);
	apiMenu();
}

function apiClassesAll(sl){
	list = nset["Start"].children;
	coreSliderList(list,0);
}

function apiClassesList(sl){
	//lists all the classes that use the selected method name
	var list = new Array();
	var theName = nset[sl[1]].name;
	var n;
	for (n in nset) {
	nextName = nset[n].name;
		if(nextName  == theName){
			var nn = n.split("."); 
			list.push(nn[0]);
		}
	}
	coreSliderList(list,1);
	var ch = config["cellheight"];
	var stripe 	= document.getElementById("stripe");
	var stripe_top = parseInt(stripe.style.top);
	slider 	= document.getElementById("api1");
	slider.style.top = stripe_top+"px";
}

function apiMethodsAll(sl){
	var list = new Array();
	for (n in nset) {
		nn = n.split(".");
		if(nn.length == 2){
			thisName = nset[n].name;
			list.push(new Array(thisName,n));
		}
	}
	list.sort();
	var lastName = null;
	var unique = new Array();
	for(a=0; a<list.length; a++){
		if (list[a][0] != lastName){
			unique.push(list[a][1]);
		}
	lastName = list[a][0];
	}
	coreSliderList(unique,0);
}
	
function apiMethodsList(sl){	
	var nn = sl[0]; 
	list =nset[nn].children;
	coreSliderList(list,1);
	var ch = config["cellheight"];
	var stripe 	= document.getElementById("stripe");
	var stripe_top = parseInt(stripe.style.top);
	slider 	= document.getElementById("api1");
	slider.style.top = stripe_top+"px";
}
	
function apiMenu(){
	list = menus["0"]["children"];
	coreSliderList(list,2);
}

function apiDeviceClasses(counter){
	if(counter == 0) return;
	sl = config["selection"];
	sl[1] = sl[0] + ".0";
	config["selection"] = sl;
	apiClassesAll(sl);
	apiMethodsList(sl);
	var ch = config["cellheight"];
	var stripe 	= document.getElementById("stripe");
	var stripe_top = parseInt(stripe.style.top);
	var slider 	= document.getElementById("api0");
	var pos = sl[0];
	var cell_top = pos * ch;
	var slider_top = stripe_top - cell_top;
	slider.style.top = slider_top+"px";
}	
	
function apiDeviceMethods(counter){
	if(counter == 0) return;
	var sl = config["selection"];
	apiMethodsAll(sl);
	var cell_top;
	var cId;
	var mn = nset[sl[1]].name;
	coll = document.getElementById("api0").childNodes;
	for(a=0; a < coll.length; a++){
		if(mn == coll[a].innerHTML){
	
			cell_top = coll[a].offsetTop;
			cId = coll[a].id;			
		}
	}
	var nn = cId.split(".")
	config["selection"][0] = nn[0];
	sl = config["selection"];
	apiClassesList(sl);
	var stripe 	= document.getElementById("stripe");
	var stripe_top = parseInt(stripe.style.top);
	var slider_top = stripe_top - cell_top;
	document.getElementById("api0").style.top = slider_top+"px";
}	

function api0Down(nn){
	nn=nn[0]
	mn = config["selection"][2];
	mn = menus[mn].name;
	if(mn == "Classes"){
		config["selection"][0] = nn;
		config["selection"][1] = nn + ".0";
		sl = config["selection"];
		apiMethodsList(sl);
	}
	if(mn == "Methods"){
		var n = nn.split(".");
		config["selection"][0] = n[0];
		config["selection"][1] = nn;
		sl = config["selection"];
		apiClassesList(sl);
	}
}

function api1Down(nn){
	nn = nn[0]
	mn = config["selection"][2];
	mn = menus[mn].name;
	if(mn == "Classes"){
		config["selection"][1] = nn;
	}
	if(mn == "Methods"){
		config["selection"][0] = nn;
	}
}

function api2Down(nn){
	counter = nn[1]
	nn = nn[0]
	nnn = nn.split(".")
	if(nnn[1] < 2 )	config["selection"][2] = nn;
	cn = config["selection"][2]
	var fun = "apiDevice"+menus[cn].name;
	try{
		eval(fun)(counter)
	}
	catch(e){
	}
}





